Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mozilla.javascript.ast
Class VariableInitializer

    java.lang.Object
      org.mozilla.javascript.Node
          org.mozilla.javascript.ast.AstNode
              org.mozilla.javascript.ast.VariableInitializer

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class VariableInitializer

extends AstNode

A variable declaration or initializer, part of a `VariableDeclaration` expression. The variable "target" can be a simple name or a destructuring form. The initializer, if present, can be any expression.

Node type is one of `Token.VAR`, `Token.CONST`, or `Token.LET`.

Nested Class Summary

Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode
`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

Nested classes/interfaces inherited from class org.mozilla.javascript.Node
`Node.NodeIterator`

Field Summary

Fields inherited from class org.mozilla.javascript.ast.AstNode
`length, parent, position`

Fields inherited from class org.mozilla.javascript.Node
`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

Constructor Summary
`VariableInitializer()`
`VariableInitializer(int pos)`
`VariableInitializer(int pos, int len)`

Method Summary
`AstNode` | `getInitializer()` Returns the initial value, or `null` if not provided
`AstNode` | `getTarget()` Returns the variable name or destructuring form
`boolean` | `isDestructuring()` Returns true if this is a destructuring assignment.
`void` | `setInitializer(AstNode initializer)` Sets the initial value expression, and sets its parent to this node.
`void` | `setNodeType(int nodeType)` Sets the node type.
`void` | `setTarget(AstNode target)` Sets the variable name or destructuring form, and sets its parent to this node.
`java.lang.String` | `toSource(int depth)` Emits source code for this node.
`void` | `visit(NodeVisitor v)` Visits this node, then the target expression, then the initializer expression if present.

Methods inherited from class org.mozilla.javascript.ast.AstNode
`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

Methods inherited from class org.mozilla.javascript.Node
`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, setDouble, setJsDoc, setLineno, setScope, setString, setType, toString, toStringTree`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### VariableInitializer

    public VariableInitializer()

### VariableInitializer

    public VariableInitializer(int pos)

### VariableInitializer

    public VariableInitializer(int pos,
                               int len)

Method Detail

### setNodeType

    public void setNodeType(int nodeType)

  Sets the node type.

  Throws:
    `java.lang.IllegalArgumentException` - if `nodeType` is not one of `Token.VAR`, `Token.CONST`, or `Token.LET`

### isDestructuring

    public boolean isDestructuring()

  Returns true if this is a destructuring assignment. If so, the initializer must be non-`null`.

  Returns:
    `true` if the `target` field is a destructuring form (an `ArrayLiteral` or `ObjectLiteral` node)

### getTarget

    public AstNode getTarget()

  Returns the variable name or destructuring form

### setTarget

    public void setTarget(AstNode target)

  Sets the variable name or destructuring form, and sets its parent to this node.

  Throws:
    `java.lang.IllegalArgumentException` - if target is `null`

### getInitializer

    public AstNode getInitializer()

  Returns the initial value, or `null` if not provided

### setInitializer

    public void setInitializer(AstNode initializer)

  Sets the initial value expression, and sets its parent to this node.

  Parameters:
    `initializer` - the initial value. May be `null`.

### toSource

    public java.lang.String toSource(int depth)

  Description copied from class: `AstNode`
  Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

  Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

  Specified by:
    `toSource` in class `AstNode`
  Parameters:
    `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

### visit

    public void visit(NodeVisitor v)

  Visits this node, then the target expression, then the initializer expression if present.

  Specified by:
    `visit` in class `AstNode`
  Parameters:
    `v` - the object to call with this node and its children

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD